#include "debugger.h"

extern	char	mneu[];
extern 	struct { char name[12]; } *inodename;

kvirtaddr(adr)
{
	return(1);
}

gocmd()
{
	if(getaddr(1)) {
		if (experr)
			return(-1);
		if (!kvirtaddr(addr.a_int)) {
			printf("must be kernel virtual address\n");
			return(-1);
		}
		dbr0ptr[EIP] = (int)addr.a_int;
	}
	dbexitflg = 1;
	return(0);
}

trcmd()
{
	if (dbwhy == 0) {		/* comming from todclock() */
		printf("Can't single step here\n");
		return(-1);
	}
	trcount = evalexp(3);
	if (experr)
		return(-1);
	dbstepflg = 1;
	if (trcount <= 0)
		trcount = 1;
	else
	if (trcount > 0xff)
		trcount = 0xff;
	dbexitflg = 1;
	((flags_t *)&dbr0ptr[EFL])->fl_tf = 1; /* turn on trace */
	return(0);
}

tocmd()
{
	if (dbwhy == 0) {		/* comming from todclock() */
		printf("Can't single step here\n");
		return(-1);
	}
	tocount = evalexp(3);
	if (experr)
		return(-1);
	dbstepflg = 2;
	if (tocount <= 0)
		tocount = 1;
	else
	if (tocount > 0xff)
		tocount = 0xff;
	dbexitflg = 1;
	return(0);
}

tocont()
{
	short	opcode;
	int	length;
	int 	adr;

	if(tocount == 0)
		return;
	tocount--;
	mneu[0] = 0;
	/*
	** translate logical address to linear
	** address if in user address space
	*/
	if (dbr0ptr[EFL] & PS_VM)		/* CS:IP is real mode addr */
		dbflags |= DB_REALMODE;
	adr = logtolin(dbr0ptr[EIP],dbr0ptr[CS]);
	dot = (char *) dis_dot(adr);
	if (strncmp(mneu, "call", 4) == 0 || strncmp(mneu+1, "call", 4) == 0) {
		((flags_t *)&dbr0ptr[EFL])->fl_tf = 0; /* turn off trace */
		setbp(dot, 0, 0, NULL, NULL);
	}
	else if (strncmp(mneu, "iret", 4) == 0) {
		adr = dbr0ptr[ESP] + 4*(EFL-EAX) + 8;
		((flags_t *)adr)->fl_tf = 1;
		trcount = 1;
	}
	else {
		((flags_t *)&dbr0ptr[EFL])->fl_tf = 1; /* turn on trace */
		trcount = 1;
	}
}

