typedef	unsigned int	uint;
typedef	unsigned short	ushort;
typedef	unsigned char	uchar;

#include "reg.h"
#include "debugreg.h"
#include "tss.h"

#define	DB_ACTIVE	0x0001
#define DB_ENABLE	0x0002
#define DB_INSTEP	0x0004
#define DB_CTRLB	0x0010
#define	DB_REALMODE	0x0100

#ifndef	NULL
#define NULL		0
#endif

#ifdef	SERIAL_KDB
#define	printf		port_printf
#define	putchar		port_putchar
#define	getchar		port_getchar
#else
#define	printf		printk
#define	putchar(c)	printk("%c", c)
#define	getchar		console_getchar
#endif

int	dbflags;
int	dbspl;

union	addr	{
	int	*a_int;
	ushort	*a_short;
	char	*a_char;
	uchar	*a_uchar;
};

char	*cmdptr;
union	addr	addr;
union	addr	laddr;
int	value;
int	tocount;
int	trcount;
int	trapret;
int	dbexitflg, dbstepflg, dbwhy;
int	remref, lremref;
int	dbcmd;
char	dbcontrol;
struct	tty 	*dbconsole;

#define MAXLINE	128

char	cmdline[MAXLINE], lastcmdline[MAXLINE];
int	experr;
int	more_started;
int	more_abort;

extern	int	*dbr0ptr;
extern	char	*dot;

