
#include "debugger.h"

puts(char *p)
{
	while(*p)
		putchar(*p++);
}

gets(char *p, int n)
{
	int	c;
	char 	*arg = p;
	char 	*s = p;
	char	*q = p + n - 1;

	for ( ;; ) {
		while((c = getchar()) == -1);

		switch(c) {
		case '\t':		/* convert tabs to spaces */
			c = ' ';
			break;
		case '\n':
		case '\r':
			putchar('\n');
			*p = 0;
			return(p - arg);
		
		case '':
		case 0x7f:	/* Backspace */
			if (p > s) {
				p--;
				if (*p < ' ' || *p == '\177')
					puts("\b\b  \b\b");
				else
					puts("\b \b");
			}
			continue;
		
		case '':	/* Kill */
			while (p > s) {
				p--;
				if (*p < ' ' || *p == '\177')
					puts("\b\b  \b\b");
				else
					puts("\b \b");
			}
			continue;

		}
		if (c < ' ')
			putchar('^'), putchar(c + '@');
		else if (c == '\177')
			puts("^?");
		else
			putchar(c);

		if (p < q)
			*p++ = c;
	}
}
