
/*
 *	Number routines
 */

#include "debugger.h"


dbtolower(c)
register int c;
{
	if(c >= 'A' && c <= 'Z')
		return(c - 'A' + 'a');
	return(c);
}

skipsp()
{
	while(*cmdptr == ' ' || *cmdptr == '\t')
		cmdptr++;
}

skipnsp()
{
	while(*cmdptr != ' ' && *cmdptr != '\t' && *cmdptr != '\0')
		cmdptr++;
}

getwaddr()
{
	if (getaddr(1) == 0)
		return(0);
	if (experr)
		return(1);
	if(((int)addr.a_int & 0x1) != 0) {
		experr = 1;
		printf("Address must be on word boundry\n");
		return(1);
	}
	return(1);
}

getaddr(terminal)
int terminal;
{
	int num;

	remref = 0;
	skipsp();
	if (*cmdptr == '\0') {
		addr.a_int = 0;
		return(0);
	}
	num = evalexp(0);
	if (experr)
		return(1);
	addr.a_int = (int *)num;
	laddr.a_int = (int *)num;
	skipsp();
	if(*cmdptr == ',') {
		cmdptr++;
		num = evalexp(terminal);
		if (experr)
			return(1);
		remref = num;
		lremref = num;
	}
	if (terminal && *cmdptr != '\0') {
		printf("extra characters after expression\n");
		experr = 1;
	}
	return(1);
}

getvalue()
{
	char	*t;

	t = cmdptr;
	value = evalexp(2);
	if (experr || t == cmdptr)
		return(0);
	return(1);
}
