
_start:
    	cli
	cld
#ifdef	WYSE
	.byte	0xb8, 0x18, 0x00 	/ mov $0x18, %ax with no 0x66
	movw	%ax, %ds		/ set ds 
	addr16
	data16
	lgdt	gdt0dscr
	data16
	.byte	0xEA			/ offset 11
	.long	start1
	.value	0x0010			/ ljump cs:start1

	.align	8		
gdt0:					/ offset 0x18 
	.long	0x00000000
	.long	0x00000000		/ null descriptor
	.long	0x00000000
	.long	0x00000000		/ null descriptor
	.long	0x0000ffff
	.long	0x00cf9a00		/ cs descriptor
	.long	0x0000ffff
	.long	0x00cf9200		/ ds descriptor

gdt0dscr:				/ offset 24 + 4 * 6 (0x1030)
	.value	0x001f			/ limit
	.long	gdt0
	.value	0x0000

start1:					/ offset 0x38
	movw	$0x18, %ax
	movw	%ax, %ds
	movw	%ax, %ss
#endif
	movl	$1, %ecx		/ rom boot, ecx != 0
	jmp	start
restart:

	cli
	movl	4(%esp), %esi		/ from
	movl	8(%esp), %edi		/ to
	movl	12(%esp), %ecx		/ count

	leal	start, %edx
	subl    $_stext, %edx
	addl	%edi, %edx		/ save starting addr 

	addl	$3, %ecx
	shrl	$2, %ecx		/ convert to count of words to copy
	
	cld				/ clear direction flag
	repz
	smovl				/ copy words, ecx = 0
	
	jmp	*%edx


	.align	8		
start:

